module adder_4_bit_tb;
  reg [3:0] a, b; //logic [3:0] a, b;
  reg c_in; //logic c_in;
  wire [3:0] sum; //logic [3:0] sum;
  wire c_out; //logic c_out;
  
  adder_4_bit a0(.c_out(c_out), .sum(sum), .c_in(c_in), .a(a), .b(b));
  
  initial begin
    a = 0; b = 0; c_in = 0;
    #10 a = 4'b0101; b = 4'b0001; c_in = 1'b0;
    #10 a = 4'b0101; b = 4'b1110; c_in = 1'b1;
    #10 a = 0; b = 0; c_in = 0;
    #10 $finish;
  end

  initial $dumpvars(0,adder_4_bit_tb); // for gtkwave

endmodule

module adder_4_bit_gen_tb;
  reg [3:0] a, b;
  reg c_in;
  wire [3:0] sum;
  wire c_out;
  
  adder_4_bit_gen a0(.c_out(c_out), .sum(sum), .c_in(c_in), .a(a), .b(b));
  
  initial begin
    a = 0; b = 0; c_in = 0;
    #10 a = 4'b0101; b = 4'b0001; c_in = 1'b0;
    #10 a = 4'b0101; b = 4'b1110; c_in = 1'b1;
    #10 a = 0; b = 0; c_in = 0;
    #10 $finish;
  end

  initial $dumpvars(0,adder_4_bit_gen_tb); // for gtkwave

endmodule
